# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1LegalBusinessProfile(Model):
    """Describes a partner's legal business profile.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param company_name: Gets or sets the legal company name.
    :type company_name: str
    :param address: Gets or sets the address of the company or organization.
    :type address:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1Address
    :param primary_contact: Gets or sets the primary contact for the company
     or organization.
    :type primary_contact:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1Contact
    :param company_approver_address: Gets or sets the company approver
     address.
    :type company_approver_address:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1Address
    :param company_approver_email: Gets or sets the company approver email.
    :type company_approver_email: str
    :param vetting_status: Gets or sets the vetting status. Possible values
     include: 'none', 'pending', 'authorized', 'rejected'
    :type vetting_status: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param vetting_sub_status: Gets or sets the vetting sub status. Possible
     values include: 'none', 'entry', 'email_ownership', 'email_domain',
     'employment_verification', 'decision', 'other', 'business_verification'
    :type vetting_sub_status: str or
     ~microsoft.store.partnercenterservices.models.enum
    :ivar profile_type: Gets the partner profile type. Possible values
     include: 'mpn_profile', 'billing_profile', 'support_profile',
     'legal_business_profile', 'organization_profile'
    :vartype profile_type: str or
     ~microsoft.store.partnercenterservices.models.enum
    :param links: Gets or sets the links.
    :type links:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceLinks
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'profile_type': {'readonly': True},
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'company_name': {'key': 'companyName', 'type': 'str'},
        'address': {'key': 'address', 'type': 'MicrosoftPartnerSdkContractsV1Address'},
        'primary_contact': {'key': 'primaryContact', 'type': 'MicrosoftPartnerSdkContractsV1Contact'},
        'company_approver_address': {'key': 'companyApproverAddress', 'type': 'MicrosoftPartnerSdkContractsV1Address'},
        'company_approver_email': {'key': 'companyApproverEmail', 'type': 'str'},
        'vetting_status': {'key': 'vettingStatus', 'type': 'str'},
        'vetting_sub_status': {'key': 'vettingSubStatus', 'type': 'str'},
        'profile_type': {'key': 'profileType', 'type': 'str'},
        'links': {'key': 'links', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceLinks'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, company_name=None, address=None, primary_contact=None, company_approver_address=None, company_approver_email=None, vetting_status=None, vetting_sub_status=None, links=None):
        super(MicrosoftPartnerSdkContractsV1LegalBusinessProfile, self).__init__()
        self.company_name = company_name
        self.address = address
        self.primary_contact = primary_contact
        self.company_approver_address = company_approver_address
        self.company_approver_email = company_approver_email
        self.vetting_status = vetting_status
        self.vetting_sub_status = vetting_sub_status
        self.profile_type = None
        self.links = links
        self.attributes = None
