# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class MicrosoftPartnerSdkContractsV1UsageManagementAzureResourceMonthlyUsageRecord(Model):
    """This class defines the monthly usage record for an Azure subscription
    resource.

    Variables are only populated by the server, and will be ignored when
    sending a request.

    :param category: The Azure resource category.
    :type category: str
    :param subcategory: The Azure resource sub-category.
    :type subcategory: str
    :param quantity_used: The quantity of the Azure resource used.
    :type quantity_used: float
    :param unit: The unit of measure for the Azure resource.
    :type unit: str
    :param resource_id: Gets or sets the resource unique identifier. A GUID
     formatted string.
    :type resource_id: str
    :param id: To do: To be deprecated: The resource unique identifier.
    :type id: str
    :param resource_name: Gets or sets the name of the resource.
    :type resource_name: str
    :param name: To do: To be deprecated soon. The name of the resource.
    :type name: str
    :param total_cost: Gets or sets the estimated total cost of using the
     resources in the subscription.
    :type total_cost: float
    :param currency_locale: Gets or sets the locale in which the subscription
     was used, determines the currency to use on the invoice.
    :type currency_locale: str
    :param last_modified_date: Gets or sets the day, in date-time format, that
     this record was last modified.
    :type last_modified_date: datetime
    :ivar attributes: Gets the attributes.
    :vartype attributes:
     ~microsoft.store.partnercenterservices.models.MicrosoftPartnerSdkContractsV1CommonResourceAttributes
    """

    _validation = {
        'attributes': {'readonly': True},
    }

    _attribute_map = {
        'category': {'key': 'category', 'type': 'str'},
        'subcategory': {'key': 'subcategory', 'type': 'str'},
        'quantity_used': {'key': 'quantityUsed', 'type': 'float'},
        'unit': {'key': 'unit', 'type': 'str'},
        'resource_id': {'key': 'resourceId', 'type': 'str'},
        'id': {'key': 'id', 'type': 'str'},
        'resource_name': {'key': 'resourceName', 'type': 'str'},
        'name': {'key': 'name', 'type': 'str'},
        'total_cost': {'key': 'totalCost', 'type': 'float'},
        'currency_locale': {'key': 'currencyLocale', 'type': 'str'},
        'last_modified_date': {'key': 'lastModifiedDate', 'type': 'iso-8601'},
        'attributes': {'key': 'attributes', 'type': 'MicrosoftPartnerSdkContractsV1CommonResourceAttributes'},
    }

    def __init__(self, category=None, subcategory=None, quantity_used=None, unit=None, resource_id=None, id=None, resource_name=None, name=None, total_cost=None, currency_locale=None, last_modified_date=None):
        super(MicrosoftPartnerSdkContractsV1UsageManagementAzureResourceMonthlyUsageRecord, self).__init__()
        self.category = category
        self.subcategory = subcategory
        self.quantity_used = quantity_used
        self.unit = unit
        self.resource_id = resource_id
        self.id = id
        self.resource_name = resource_name
        self.name = name
        self.total_cost = total_cost
        self.currency_locale = currency_locale
        self.last_modified_date = last_modified_date
        self.attributes = None
